
Broadly speaking, the energy and power aware job scheduling and
resource management approaches identified in the survey fall into
two categories:

\begin{itemize}

\item \emph{Approaches oriented toward managing idle resources.}

\item \emph{Approaches oriented toward managing active resources.}

\end{itemize}

The following subsections explore these two broad categories in greater
detail.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\underline{Managing Idle Resources}
\label{sec:Analysis:Idle}

This section will talk about managing the energy consumption of idle resources.
Related approaches include making occupied resources idle by killing jobs.
The section needs to talk about the Japanese supercomputing centers who have
hard limits on energy consumption envelopes during summer months and need to
get below a threshhold quickly.  Do other sites do this too??  The Japanese
sites are motivated by energy constraints that force them to accommodate
limits to peak power drawn for fluctuations in power availability.  If there
are other sites that do this approach, try to figure out what their motivations
might be.

\begin{itemize}

\item Shutting Down Idle Nodes -- foo.
Reducing P-State of Idle CPUs or GPUs -- bar.

\item Dynamic Job Termination is a brute-force method of tackling
system-wide power constraint is to actively detect occasions where the
total system power-draw approaches the constraining limit, and to
terminate specific jobs to avoid the limit.  The list of candidate
jobs that are selected for such termination depend on a number of
parameters such as job length, job size, etc. Choosing the right set
of parameters, and explaining the rationale behind forced termination
to the end-users are the main challenges with this approach. In
addition, the power spent on incomplete execution of applications
remains irretrievable.

\item Automated reduction of node availability -- Another approach is to
limit the total number of compute nodes available for job
allocation. Limiting the node-count, either dynamically, or during
queue release, reduces the theoretical maximum value of the total
power consumption by the system. The advantage of this approach over
the one above is that jobs do not have to be forcefully shut down once
allocated to a compute node. The downside however, is that the drop in
total node-count reduces the system utilization. Also, due to a
shortage of compute resources, newly submitted jobs spend a longer
time waiting in the job queue, which in turn affects the productivity
of the end users.
\end{itemize}


Supercomputers typically have a lifespan of around 5 years.  Accordingly,
supercomputing centers tend to try to maintain a constant high utilization
except during scheduled maintenance windows.  This characteristic means
that supercomputing resources are often not idle.  The next section discusses
approaches for managing active resources.


\underline{Managing Active Resources}

These approaches try to find a balance among competing factors such as
machine stability, utilization, and resource efficiency.  They may be
motivated by a specific dictate from the funding agency (such as STFC's
case) that specifies something like a specific PUE in order to spend
a better fraction of funding on computing vs. infrastructure.


\begin{itemize}


	\item Matching power supply to power demand

[Why \_static\_ prediction models? I would just call them prediction models]
\item Static Prediction Models -- Some sites have reported incorporating
prediction models within their system-wide resource managers. The
purpose of the model is to predict a set of system configuration
parameters (e.g. ideal operating frequency, power caps, etc) for a
given application. These techniques require maintenance of historic
data of past application runs. The main challenge with this approach
is the identification of the right set of input parameters that are
needed to build a stable, scalable, and reliable model.

\item Tagging Applications -- While the previous approach requires a
prediction model, this approach transfers the responsibility of
setting the system configuration to the end user. The user is
responsible for assigning a “tag value” to a given application. The
system is designed to map these “tags” to a set of system
configuration parameters. The challenge with this approach is that the
reliability of the solution is completely dependant on the user’s
ability to understand the application demands and choose the correct
tag value.

%\item Static Prediction Models -- Some sites have reported incorporating prediction models within their
%system-wide resource managers. The purpose of the model is to predict
%a set of system configuration parameters (e.g. ideal operating
%frequency, power caps, etc) for a given application. These techniques
%require maintenance of historic data of past application runs. The
%main challenge with this approach is the identification of the right
%set of input parameters that are needed to build a stable, scalable,
%and reliable model.

[Which site does topology-aware job placement?]
\item Topology-Aware Job Placement -- This approach takes into consideration
the communication patterns employed by the job and attempts to place
the processing elements of a parallel job onto resources in such a way
as to optimize communication.  This requires capturing historic data
about communication patterns, requiring instrumentation in the runtime
layer, and requires leveraging this historic data for PE placement,
requiring cooperation of the job scheduling and resource management
middleware.  Energy consumption improves directly because less network
hardware is energized in running the job.  Energy consumption improves
indirectly due to improving performance of the job related to
communication performance.
\end{itemize}

Talk about vendor support here.  The idea is that the approaches
described in this subsection are more sophisticated and end up
relying a lot more on vendor support to be successful.
